/**
 * 
 */
package org.elsys.pluginsample.editor;

import java.util.List;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.IInputValidator;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.viewers.ListViewer;
import org.eclipse.ui.IEditorSite;

/**
 * @author kiko
 * 
 */
public class AddAction extends Action {

	private ListViewer fViewer;

	private ListEditor fEditor;

	private List<String> fContent;

	public AddAction(ListEditor editor, List<String> content, ListViewer viewer) {
		super();
		setText("Add");
		fViewer = viewer;
		fEditor = editor;
		fContent = content;
	}

	@Override
	public void run() {
		InputDialog dialog = new InputDialog(fEditor.getSite().getShell(),
				"Input string", "Add a string", "", new IInputValidator() {
					public String isValid(String newText) {
						return null;
					}
				});
		if (dialog.open() == IDialogConstants.OK_ID) {
			fContent.add(dialog.getValue());
			fViewer.refresh();
			fEditor.setDirty();
		}
	}

}
