/**
 * 
 */
package org.elsys.pluginsample.editor;

import java.util.List;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.ListViewer;
import org.eclipse.jface.viewers.SelectionChangedEvent;

/**
 * @author kiko
 * 
 */
public class DeleteAction extends Action {

	private ListViewer fViewer;

	private ListEditor fEditor;

	private List<String> fContent;

	public DeleteAction(ListEditor editor, List<String> content,
			ListViewer viewer) {
		super();
		setText("Delete");
		fViewer = viewer;
		fEditor = editor;
		fContent = content;
		fViewer.addSelectionChangedListener(new ISelectionChangedListener() {

			public void selectionChanged(SelectionChangedEvent event) {
				if (((IStructuredSelection) fViewer.getSelection()).isEmpty() == false) {
					setEnabled(true);
				} else
					setEnabled(false);
			}

		});
	}

	@Override
	public void run() {
		IStructuredSelection selection = (IStructuredSelection) fViewer
				.getSelection();
		fContent.remove(selection.getFirstElement());
		fViewer.refresh();
		fEditor.setDirty();
	}

}
